package Welcome;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import Welcome.parts.*;

public class AppFrame extends JFrame
{
  //Car-Object member:
  Car oCar=new Car(    new BMW3_Engine(),
                       new BMW3_Tire(),
                       new BMW3_Tire(),
                       new BMW3_Tire(),
                       new BMW3_Tire()
                       );
  int max_km=280000;
  //----------------------------------
  //GUI-Stuff:
  //----------------------------------
  XYLayout xYLayout1 = new XYLayout();
  JPanel jPanel1 = new JPanel();
  JButton BT_Start = new JButton();
  JButton BT_Stop = new JButton();
  XYLayout xYLayout2 = new XYLayout();
  JTextField TXT_Msg = new JTextField();
  JProgressBar jProgressBar1 = new JProgressBar
  (JProgressBar.HORIZONTAL,0,max_km);
  JButton BT_Help = new JButton();

//**********************************
// Start-Button Action Handler:
//**********************************
public void Start()
{
   String sTemp="";

   while(oCar.km<max_km)
   {
     oCar.Drive(10000);
     ShowProgress(oCar.km);

     if(oCar.TireKM()>=oCar.MaxTireKM())
     {
      sTemp="Tire replaced("+oCar.km+"km) Press Start to Continue";
      TXT_Msg.setText(sTemp);
      TXT_Msg.setForeground(Color.red);
      oCar.ReplaceTire();

      return;
     }

     if(oCar.EngineKM()>=oCar.MaxEngineKM())
     {
      sTemp="Engine replaced("+oCar.km+"km)Press Start to Continue";
      TXT_Msg.setText(sTemp);
      TXT_Msg.setForeground(Color.blue);
      oCar.ReplaceEngine();
      return;
     };
  };//END OF: while

  TXT_Msg.setForeground(Color.black);
  sTemp="Done! It's time to by a new car!("+oCar.km+" km)";
  TXT_Msg.setText(sTemp);
  BT_Start.setEnabled(false);
}

//**********************************
// Frame-Constructor:
//**********************************
  public AppFrame()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

//**********************************
//GUI-Component initialization
//**********************************
  private void jbInit() throws Exception
  {
    //Component Text:
    this.setTitle("Car-Simulator");
    BT_Start.setText("Start");
    BT_Stop.setText("Stop");
    BT_Help.setText("Help");
    TXT_Msg.setText("Car: "+oCar.GetParts());

    //Component Initialisation
    this.getContentPane().setLayout(xYLayout1);
    jPanel1.setLayout(xYLayout2);
    TXT_Msg.setRequestFocusEnabled(false);
    this.getContentPane().add(jPanel1, new XYConstraints(-3, 3, 397, 83));
    jPanel1.add(jProgressBar1, new XYConstraints(10, 46, 380, 26));
    jPanel1.add(TXT_Msg, new XYConstraints(11, 9, 383, 25));
    this.getContentPane().add(BT_Stop, new XYConstraints(178, 88, -1, -1));
    this.getContentPane().add(BT_Start, new XYConstraints(83, 89, -1, -1));
    this.getContentPane().add(BT_Help, new XYConstraints(278, 88, -1, -1));
    this.setSize(new Dimension(400, 151));

    //Add action-handlers to buttons:
    BT_Start.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {Start();}
      });

    BT_Stop.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {System.exit(0);} //Exit on Stop
      });

    BT_Help.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        {Do_Help();}
      });
  }

//**********************************
//Overridden so we can exit on System Close
//**********************************
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }

//**********************************
// Update for Progress-Bar
//**********************************
 public void ShowProgress(int km)
 {
   jProgressBar1.setValue(km);
 }

//**********************************
// Update for Progress-Bar
//**********************************
  public void Do_Help()
  {
    HelpBox dlg = new HelpBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }
//EOF
}